<?php 

/** 
 * Plugin Name: CTY
 *  * Plugin URI: https://yucca-crm.fr/
 * Description: API REST permettant de communiquer avec votre instance YUCCA
 *  * Version: 0.1
 * Author: Dave DELALLEAU
 * Author URI: https://www.davelopweb.fr/#contact
 *
 */
 
if (!class_exists("yucca_rest")){
	class yucca_rest{
		function getcontactsyucca(){
			
			ob_start();

			$url = "https://".get_option('lien_crm')."/rest/".md5($_SERVER['SERVER_NAME']);
	
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
			$response = curl_exec($ch);
			$error = curl_error($ch);
			curl_close($ch);
			
			if ($response) 
			{

				$result = json_decode($response,TRUE);
				
				echo "<h2>Listing de vos contacts Yucca décryptés</h2>";

				foreach($result as $decrypt){
					
					echo "<p>".yucca_dec($decrypt['prenom'])." ".yucca_dec($decrypt['nom'])." ".yucca_dec($decrypt['email'])."</p>";
					
				};
				
				echo "<br><p><i>Vérifiez votre clé de cryptage dans les paramètres si vide</i></p>";

			};

			return ob_get_clean();
		}
	}
}	

$yucca_rest=new yucca_rest();
add_shortcode('testrest',array($yucca_rest,'getcontactsyucca'));

//fonction décryptage des données reçues de yucca
function yucca_dec($data){
	$data_enc= substr($data, 0,-16);
	$iv_enc= substr($data,-16);
	$datadecrypt = openssl_decrypt($data_enc,'aes256',get_option('key_crm'),0,$iv_enc);
	return stripcslashes(htmlspecialchars_decode($datadecrypt));		
};

/*url rewriting projets*/
function yucca_rewrite_url() {
    
    add_rewrite_tag( '%projet%','([^&]+)' );
    
    add_rewrite_rule(
      'vos-projets/([^/]+)',
      'index.php?pagename=vos-projets&projet=$matches[1]',
      'top'
    );
    
    add_filter( 'the_title', 'do_shortcode' ); 
       
	//rankmath
	add_filter( 'rank_math/frontend/title', function( $title ) {
		$title = do_shortcode($title);
		return $title;
	});
	add_filter( 'rank_math/frontend/description', function( $description ) {
		$description = do_shortcode($description);
		return $description;
	});    
    
}
add_action( 'init', 'yucca_rewrite_url' );



/*
 * css
 */

function css_yucca() {
	wp_enqueue_style( 'CSS_YUCCA', plugins_url( '/css/style.css', __FILE__ ) );
}
add_action( 'wp_enqueue_scripts', 'css_yucca' );

/*menu administration*/
if ( is_admin() ){ // admin actions
	add_action('admin_menu','yucca_rest_setup_menu');
	add_action( 'admin_init', 'register_crmsettings' );
	
	function register_crmsettings() {
	  register_setting( 'yucca_rest-group', 'lien_crm' );
	  register_setting( 'yucca_rest-group', 'key_crm' );
	}
	function yucca_rest_setup_menu(){
		  add_submenu_page('options-general.php', 'Connect to Yucca', 'Connect to Yucca','manage_options', 'Connect to Yucca', 'param_yucca_rest' );
	}
}
		
/*page admin*/
function param_yucca_rest(){?>
      <div class="wrap">
		<h2>Configuration de votre CRM</h2>
		<p>Requetes API REST</p>
		<form method="post" action="options.php"> 
		<?php 
		settings_fields( 'yucca_rest-group' );
		do_settings_fields( 'yucca_rest-group','lien_crm' );?>
		
		<table class="form-table">
			<tr valign="top">
			<th scope="row">Lien de votre instance YUCCA</th>
			<td><input type="text" name="lien_crm" value="<?php echo get_option('lien_crm'); ?>" placeholder="Nom de domaine Yucca sans https://"/></td>
			</tr>
			<tr valign="top">
			<th scope="row">Clé de cryptage indiquée dans les paramètres de votre CRM</th>
			<td><input type="text" name="key_crm" value="<?php echo get_option('key_crm'); ?>" /></td>
			</tr>			
			
			
		</table>
		
		<?submit_button(); ?>
		</form>
		</div>
<?}
